using System;
using System.Data;
using System.Text;
using System.Data.SqlClient;
using CallCenterApi.DB;

namespace CallCenterApi.DAL
{
    /// <summary>
    /// 数据访问类:T_Sys_Department
    /// </summary>
    public partial class T_Sys_Department
    {
        public T_Sys_Department()
        { }
        #region  BasicMethod
        /// <summary>
        /// 是否存在该记录
        /// </summary>
        public bool Exists(int F_DeptId)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("select count(1) from T_Sys_Department");
            strSql.Append(" where F_DeptId=@F_DeptId");
            SqlParameter[] parameters = {
                    new SqlParameter("@F_DeptId", SqlDbType.Int,4)
            };
            parameters[0].Value = F_DeptId;

            return DbHelperSQL.Exists(strSql.ToString(), parameters);
        }


        /// <summary>
        /// 增加一条数据
        /// </summary>
        public int Add(CallCenterApi.Model.T_Sys_Department model)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("insert into T_Sys_Department(");
            strSql.Append("F_DeptName,F_DeptNameSpell,F_DeptNameSpells,F_DeptPhone,F_DeptPhone2,F_DeptTelphone,F_PartentId,F_layer,F_Sort,F_Type,F_Address,F_Remark,F_LeaderUser,F_LeaderUserName,F_TopSplitUser,F_TopSplitUserName,F_TopLeaderUser,F_TopLeaderUserName,F_State,F_CreateUser,F_CreateDate,F_IsDept,F_IsDealDept)");
            strSql.Append(" values (");
            strSql.Append("@F_DeptName,@F_DeptNameSpell,@F_DeptNameSpells,@F_DeptPhone,@F_DeptPhone2,@F_DeptTelphone,@F_PartentId,@F_layer,@F_Sort,@F_Type,@F_Address,@F_Remark,@F_LeaderUser,@F_LeaderUserName,@F_TopSplitUser,@F_TopSplitUserName,@F_TopLeaderUser,@F_TopLeaderUserName,@F_State,@F_CreateUser,@F_CreateDate,@F_IsDept,@F_IsDealDept)");
            strSql.Append(";select @@IDENTITY");
            SqlParameter[] parameters = {
                    new SqlParameter("@F_DeptName", SqlDbType.NVarChar,100),
                    new SqlParameter("@F_DeptNameSpell", SqlDbType.NVarChar,100),
                    new SqlParameter("@F_DeptNameSpells", SqlDbType.NVarChar,500),
                    new SqlParameter("@F_DeptPhone", SqlDbType.NVarChar,20),
                    new SqlParameter("@F_DeptPhone2", SqlDbType.NVarChar,20),
                    new SqlParameter("@F_DeptTelphone", SqlDbType.NVarChar,20),
                    new SqlParameter("@F_PartentId", SqlDbType.Int,4),
                    new SqlParameter("@F_layer", SqlDbType.Int,4),
                    new SqlParameter("@F_Sort", SqlDbType.Int,4),
                    new SqlParameter("@F_Type", SqlDbType.Int,4),
                    new SqlParameter("@F_Address", SqlDbType.NVarChar,200),
                    new SqlParameter("@F_Remark", SqlDbType.NVarChar,200),
                    new SqlParameter("@F_LeaderUser", SqlDbType.VarChar,50),
                    new SqlParameter("@F_LeaderUserName", SqlDbType.VarChar,50),
                    new SqlParameter("@F_TopSplitUser", SqlDbType.VarChar,50),
                    new SqlParameter("@F_TopSplitUserName", SqlDbType.VarChar,50),
                    new SqlParameter("@F_TopLeaderUser", SqlDbType.VarChar,50),
                    new SqlParameter("@F_TopLeaderUserName", SqlDbType.VarChar,50),
                    new SqlParameter("@F_State", SqlDbType.Int,4),
                    new SqlParameter("@F_CreateUser", SqlDbType.VarChar,50),
                    new SqlParameter("@F_CreateDate", SqlDbType.DateTime),
                    new SqlParameter("@F_IsDept", SqlDbType.Int,4),
                    new SqlParameter("@F_IsDealDept", SqlDbType.Int,4)};
            parameters[0].Value = model.F_DeptName;
            parameters[1].Value = model.F_DeptNameSpell;
            parameters[2].Value = model.F_DeptNameSpells;
            parameters[3].Value = model.F_DeptPhone;
            parameters[4].Value = model.F_DeptPhone2;
            parameters[5].Value = model.F_DeptTelphone;
            parameters[6].Value = model.F_PartentId;
            parameters[7].Value = model.F_layer;
            parameters[8].Value = model.F_Sort;
            parameters[9].Value = model.F_Type;
            parameters[10].Value = model.F_Address;
            parameters[11].Value = model.F_Remark;
            parameters[12].Value = model.F_LeaderUser;
            parameters[13].Value = model.F_LeaderUserName;
            parameters[14].Value = model.F_TopSplitUser;
            parameters[15].Value = model.F_TopSplitUserName;
            parameters[16].Value = model.F_TopLeaderUser;
            parameters[17].Value = model.F_TopLeaderUserName;
            parameters[18].Value = model.F_State;
            parameters[19].Value = model.F_CreateUser;
            parameters[20].Value = model.F_CreateDate;
            parameters[21].Value = model.F_IsDept;
            parameters[22].Value = model.F_IsDealDept;

            object obj = DbHelperSQL.GetSingle(strSql.ToString(), parameters);
            if (obj == null)
            {
                return 0;
            }
            else
            {
                return Convert.ToInt32(obj);
            }
        }
        /// <summary>
        /// 更新一条数据
        /// </summary>
        public bool Update(CallCenterApi.Model.T_Sys_Department model)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("update T_Sys_Department set ");
            strSql.Append("F_DeptName=@F_DeptName,");
            strSql.Append("F_DeptNameSpell=@F_DeptNameSpell,");
            strSql.Append("F_DeptNameSpells=@F_DeptNameSpells,");
            strSql.Append("F_DeptPhone=@F_DeptPhone,");
            strSql.Append("F_DeptPhone2=@F_DeptPhone2,");
            strSql.Append("F_DeptTelphone=@F_DeptTelphone,");
            strSql.Append("F_PartentId=@F_PartentId,");
            strSql.Append("F_layer=@F_layer,");
            strSql.Append("F_Sort=@F_Sort,");
            strSql.Append("F_Type=@F_Type,");
            strSql.Append("F_Address=@F_Address,");
            strSql.Append("F_Remark=@F_Remark,");
            strSql.Append("F_LeaderUser=@F_LeaderUser,");
            strSql.Append("F_LeaderUserName=@F_LeaderUserName,");
            strSql.Append("F_TopSplitUser=@F_TopSplitUser,");
            strSql.Append("F_TopSplitUserName=@F_TopSplitUserName,");
            strSql.Append("F_TopLeaderUser=@F_TopLeaderUser,");
            strSql.Append("F_TopLeaderUserName=@F_TopLeaderUserName,");
            strSql.Append("F_State=@F_State,");
            strSql.Append("F_CreateUser=@F_CreateUser,");
            strSql.Append("F_CreateDate=@F_CreateDate,");
            strSql.Append("F_IsDept=@F_IsDept,");
            strSql.Append("F_IsDealDept=@F_IsDealDept");
            strSql.Append(" where F_DeptId=@F_DeptId");
            SqlParameter[] parameters = {
                    new SqlParameter("@F_DeptName", SqlDbType.NVarChar,100),
                    new SqlParameter("@F_DeptNameSpell", SqlDbType.NVarChar,100),
                    new SqlParameter("@F_DeptNameSpells", SqlDbType.NVarChar,500),
                    new SqlParameter("@F_DeptPhone", SqlDbType.NVarChar,20),
                    new SqlParameter("@F_DeptPhone2", SqlDbType.NVarChar,20),
                    new SqlParameter("@F_DeptTelphone", SqlDbType.NVarChar,20),
                    new SqlParameter("@F_PartentId", SqlDbType.Int,4),
                    new SqlParameter("@F_layer", SqlDbType.Int,4),
                    new SqlParameter("@F_Sort", SqlDbType.Int,4),
                    new SqlParameter("@F_Type", SqlDbType.Int,4),
                    new SqlParameter("@F_Address", SqlDbType.NVarChar,200),
                    new SqlParameter("@F_Remark", SqlDbType.NVarChar,200),
                    new SqlParameter("@F_LeaderUser", SqlDbType.VarChar,50),
                    new SqlParameter("@F_LeaderUserName", SqlDbType.VarChar,50),
                    new SqlParameter("@F_TopSplitUser", SqlDbType.VarChar,50),
                    new SqlParameter("@F_TopSplitUserName", SqlDbType.VarChar,50),
                    new SqlParameter("@F_TopLeaderUser", SqlDbType.VarChar,50),
                    new SqlParameter("@F_TopLeaderUserName", SqlDbType.VarChar,50),
                    new SqlParameter("@F_State", SqlDbType.Int,4),
                    new SqlParameter("@F_CreateUser", SqlDbType.VarChar,50),
                    new SqlParameter("@F_CreateDate", SqlDbType.DateTime),
                    new SqlParameter("@F_IsDept", SqlDbType.Int,4),
                    new SqlParameter("@F_IsDealDept", SqlDbType.Int,4),
                    new SqlParameter("@F_DeptId", SqlDbType.Int,4)};
            parameters[0].Value = model.F_DeptName;
            parameters[1].Value = model.F_DeptNameSpell;
            parameters[2].Value = model.F_DeptNameSpells;
            parameters[3].Value = model.F_DeptPhone;
            parameters[4].Value = model.F_DeptPhone2;
            parameters[5].Value = model.F_DeptTelphone;
            parameters[6].Value = model.F_PartentId;
            parameters[7].Value = model.F_layer;
            parameters[8].Value = model.F_Sort;
            parameters[9].Value = model.F_Type;
            parameters[10].Value = model.F_Address;
            parameters[11].Value = model.F_Remark;
            parameters[12].Value = model.F_LeaderUser;
            parameters[13].Value = model.F_LeaderUserName;
            parameters[14].Value = model.F_TopSplitUser;
            parameters[15].Value = model.F_TopSplitUserName;
            parameters[16].Value = model.F_TopLeaderUser;
            parameters[17].Value = model.F_TopLeaderUserName;
            parameters[18].Value = model.F_State;
            parameters[19].Value = model.F_CreateUser;
            parameters[20].Value = model.F_CreateDate;
            parameters[21].Value = model.F_IsDept;
            parameters[22].Value = model.F_IsDealDept;
            parameters[23].Value = model.F_DeptId;

            int rows = DbHelperSQL.ExecuteSql(strSql.ToString(), parameters);
            if (rows > 0)
            {
                return true;
            }
            else
            {
                return false;
            }
        }

        /// <summary>
        /// 删除一条数据
        /// </summary>
        public bool Delete(int F_DeptId)
        {

            StringBuilder strSql = new StringBuilder();
            strSql.Append("delete from T_Sys_Department ");
            strSql.Append(" where F_DeptId=@F_DeptId");
            SqlParameter[] parameters = {
                    new SqlParameter("@F_DeptId", SqlDbType.Int,4)
            };
            parameters[0].Value = F_DeptId;

            int rows = DbHelperSQL.ExecuteSql(strSql.ToString(), parameters);
            if (rows > 0)
            {
                return true;
            }
            else
            {
                return false;
            }
        }
        /// <summary>
        /// 批量删除数据
        /// </summary>
        public bool DeleteList(string F_DeptIdlist)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("delete from T_Sys_Department ");
            strSql.Append(" where F_DeptId in (" + F_DeptIdlist + ")  ");
            int rows = DbHelperSQL.ExecuteSql(strSql.ToString());
            if (rows > 0)
            {
                return true;
            }
            else
            {
                return false;
            }
        }


        /// <summary>
        /// 得到一个对象实体
        /// </summary>
        public CallCenterApi.Model.T_Sys_Department GetModel(int F_DeptId)
        {

            StringBuilder strSql = new StringBuilder();
            strSql.Append("select  top 1 F_DeptId,F_DeptName,F_DeptNameSpell,F_DeptNameSpells,F_DeptPhone,F_DeptPhone2,F_DeptTelphone,F_PartentId,F_layer,F_Sort,F_Type,F_Address,F_Remark,F_LeaderUser,F_LeaderUserName,F_TopSplitUser,F_TopSplitUserName,F_TopLeaderUser,F_TopLeaderUserName,F_State,F_CreateUser,F_CreateDate,F_IsDept,F_IsDealDept from T_Sys_Department ");
            strSql.Append(" where F_DeptId=@F_DeptId");
            SqlParameter[] parameters = {
                    new SqlParameter("@F_DeptId", SqlDbType.Int,4)
            };
            parameters[0].Value = F_DeptId;

            CallCenterApi.Model.T_Sys_Department model = new CallCenterApi.Model.T_Sys_Department();
            DataSet ds = DbHelperSQL.Query(strSql.ToString(), parameters);
            if (ds.Tables[0].Rows.Count > 0)
            {
                return DataRowToModel(ds.Tables[0].Rows[0]);
            }
            else
            {
                return null;
            }
        }


        /// <summary>
        /// 得到一个对象实体
        /// </summary>
        public CallCenterApi.Model.T_Sys_Department DataRowToModel(DataRow row)
        {
            CallCenterApi.Model.T_Sys_Department model = new CallCenterApi.Model.T_Sys_Department();
            if (row != null)
            {
                if (row["F_DeptId"] != null && row["F_DeptId"].ToString() != "")
                {
                    model.F_DeptId = int.Parse(row["F_DeptId"].ToString());
                }
                if (row["F_DeptName"] != null)
                {
                    model.F_DeptName = row["F_DeptName"].ToString();
                }
                if (row["F_DeptNameSpell"] != null)
                {
                    model.F_DeptNameSpell = row["F_DeptNameSpell"].ToString();
                }
                if (row["F_DeptNameSpells"] != null)
                {
                    model.F_DeptNameSpells = row["F_DeptNameSpells"].ToString();
                }
                if (row["F_DeptPhone"] != null)
                {
                    model.F_DeptPhone = row["F_DeptPhone"].ToString();
                }
                if (row["F_DeptPhone2"] != null)
                {
                    model.F_DeptPhone2 = row["F_DeptPhone2"].ToString();
                }
                if (row["F_DeptTelphone"] != null)
                {
                    model.F_DeptTelphone = row["F_DeptTelphone"].ToString();
                }
                if (row["F_PartentId"] != null && row["F_PartentId"].ToString() != "")
                {
                    model.F_PartentId = int.Parse(row["F_PartentId"].ToString());
                }
                if (row["F_layer"] != null && row["F_layer"].ToString() != "")
                {
                    model.F_layer = int.Parse(row["F_layer"].ToString());
                }
                if (row["F_Sort"] != null && row["F_Sort"].ToString() != "")
                {
                    model.F_Sort = int.Parse(row["F_Sort"].ToString());
                }
                if (row["F_Type"] != null && row["F_Type"].ToString() != "")
                {
                    model.F_Type = int.Parse(row["F_Type"].ToString());
                }
                if (row["F_Address"] != null)
                {
                    model.F_Address = row["F_Address"].ToString();
                }
                if (row["F_Remark"] != null)
                {
                    model.F_Remark = row["F_Remark"].ToString();
                }
                if (row["F_LeaderUser"] != null)
                {
                    model.F_LeaderUser = row["F_LeaderUser"].ToString();
                }
                if (row["F_LeaderUserName"] != null)
                {
                    model.F_LeaderUserName = row["F_LeaderUserName"].ToString();
                }
                if (row["F_TopSplitUser"] != null)
                {
                    model.F_TopSplitUser = row["F_TopSplitUser"].ToString();
                }
                if (row["F_TopSplitUserName"] != null)
                {
                    model.F_TopSplitUserName = row["F_TopSplitUserName"].ToString();
                }
                if (row["F_TopLeaderUser"] != null)
                {
                    model.F_TopLeaderUser = row["F_TopLeaderUser"].ToString();
                }
                if (row["F_TopLeaderUserName"] != null)
                {
                    model.F_TopLeaderUserName = row["F_TopLeaderUserName"].ToString();
                }
                if (row["F_State"] != null && row["F_State"].ToString() != "")
                {
                    model.F_State = int.Parse(row["F_State"].ToString());
                }
                if (row["F_CreateUser"] != null)
                {
                    model.F_CreateUser = row["F_CreateUser"].ToString();
                }
                if (row["F_CreateDate"] != null && row["F_CreateDate"].ToString() != "")
                {
                    model.F_CreateDate = DateTime.Parse(row["F_CreateDate"].ToString());
                }
                if (row["F_IsDept"] != null && row["F_IsDept"].ToString() != "")
                {
                    model.F_IsDept = int.Parse(row["F_IsDept"].ToString());
                }
                if (row["F_IsDealDept"] != null && row["F_IsDealDept"].ToString() != "")
                {
                    model.F_IsDealDept = int.Parse(row["F_IsDealDept"].ToString());
                }
            }
            return model;
        }

        /// <summary>
        /// 获得数据列表
        /// </summary>
        public DataSet GetList(string strWhere)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("select F_DeptId,F_DeptName,F_DeptNameSpell,F_DeptNameSpells,F_DeptPhone,F_DeptPhone2,F_DeptTelphone,F_PartentId,F_layer,F_Sort,F_Type,F_Address,F_Remark,F_LeaderUser,F_LeaderUserName,F_TopSplitUser,F_TopSplitUserName,F_TopLeaderUser,F_TopLeaderUserName,F_State,F_CreateUser,F_CreateDate,F_IsDept,F_IsDealDept ");
            strSql.Append(" FROM T_Sys_Department ");
            if (strWhere.Trim() != "")
            {
                strSql.Append(" where " + strWhere);
            }
            return DbHelperSQL.Query(strSql.ToString());
        }

        /// <summary>
        /// 获得前几行数据
        /// </summary>
        public DataSet GetList(int Top, string strWhere, string filedOrder)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("select ");
            if (Top > 0)
            {
                strSql.Append(" top " + Top.ToString());
            }
            strSql.Append(" F_DeptId,F_DeptName,F_DeptNameSpell,F_DeptNameSpells,F_DeptPhone,F_DeptPhone2,F_DeptTelphone,F_PartentId,F_layer,F_Sort,F_Type,F_Address,F_Remark,F_LeaderUser,F_LeaderUserName,F_TopSplitUser,F_TopSplitUserName,F_TopLeaderUser,F_TopLeaderUserName,F_State,F_CreateUser,F_CreateDate,F_IsDept,F_IsDealDept ");
            strSql.Append(" FROM T_Sys_Department ");
            if (strWhere.Trim() != "")
            {
                strSql.Append(" where " + strWhere);
            }
            strSql.Append(" order by " + filedOrder);
            return DbHelperSQL.Query(strSql.ToString());
        }

        /// <summary>
        /// 获取记录总数
        /// </summary>
        public int GetRecordCount(string strWhere)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("select count(1) FROM T_Sys_Department ");
            if (strWhere.Trim() != "")
            {
                strSql.Append(" where " + strWhere);
            }
            object obj = DbHelperSQL.GetSingle(strSql.ToString());
            if (obj == null)
            {
                return 0;
            }
            else
            {
                return Convert.ToInt32(obj);
            }
        }
        /// <summary>
        /// 分页获取数据列表
        /// </summary>
        public DataSet GetListByPage(string strWhere, string orderby, int startIndex, int endIndex)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("SELECT * FROM ( ");
            strSql.Append(" SELECT ROW_NUMBER() OVER (");
            if (!string.IsNullOrEmpty(orderby.Trim()))
            {
                strSql.Append("order by T." + orderby);
            }
            else
            {
                strSql.Append("order by T.F_DeptId desc");
            }
            strSql.Append(")AS Row, T.*  from T_Sys_Department T ");
            if (!string.IsNullOrEmpty(strWhere.Trim()))
            {
                strSql.Append(" WHERE " + strWhere);
            }
            strSql.Append(" ) TT");
            strSql.AppendFormat(" WHERE TT.Row between {0} and {1}", startIndex, endIndex);
            return DbHelperSQL.Query(strSql.ToString());
        }

        /*
		/// <summary>
		/// 分页获取数据列表
		/// </summary>
		public DataSet GetList(int PageSize,int PageIndex,string strWhere)
		{
			SqlParameter[] parameters = {
					new SqlParameter("@tblName", SqlDbType.VarChar, 255),
					new SqlParameter("@fldName", SqlDbType.VarChar, 255),
					new SqlParameter("@PageSize", SqlDbType.Int),
					new SqlParameter("@PageIndex", SqlDbType.Int),
					new SqlParameter("@IsReCount", SqlDbType.Bit),
					new SqlParameter("@OrderType", SqlDbType.Bit),
					new SqlParameter("@strWhere", SqlDbType.VarChar,1000),
					};
			parameters[0].Value = "T_Sys_Department";
			parameters[1].Value = "F_DeptId";
			parameters[2].Value = PageSize;
			parameters[3].Value = PageIndex;
			parameters[4].Value = 0;
			parameters[5].Value = 0;
			parameters[6].Value = strWhere;	
			return DbHelperSQL.RunProcedure("UP_GetRecordByPage",parameters,"ds");
		}*/

        #endregion  BasicMethod
        #region  ExtensionMethod

        #endregion  ExtensionMethod
    }
}

